/*
 Rocrail - Model Railroad Software

 Copyright (C) Rob Versluis <r.j.versluis@rocrail.net>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef __operatordlg__
#define __operatordlg__

/**
@file
Subclass of operatordlggen, which is generated by wxFormBuilder.
*/

#include "operatordlggen.h"
#include "basenotebook.h"

#include "rocs/public/node.h"

/** Implementing operatordlggen */
class OperatorDlg : public operatordlggen
{
  iONode m_Props;
  bool   m_bSave;
  int    m_TabAlign;
  int    m_SetPage;

  void initLabels();
  void evaluate();
  void initIndex();
  void initValues();
  void initConsist();
  void initLocos();
  void initLocationCombo();

public:
	/** Constructor */
	OperatorDlg( wxWindow* parent, iONode p_Props );

	void onNewOperator( wxCommandEvent& event );
    void onDelOperator( wxCommandEvent& event );
    void onLocoImage( wxCommandEvent& event );
    void onLocomotiveCombo( wxCommandEvent& event );
    void onReserve( wxCommandEvent& event );
    void onRun( wxCommandEvent& event );
    void onGotoMan( wxCommandEvent& event );
    void onCarImage( wxCommandEvent& event );
    void onAddCar( wxCommandEvent& event );
    void onLeaveCar( wxCommandEvent& event );
    void onCarCard( wxCommandEvent& event );
    void onWayBill( wxCommandEvent& event );
    void onApply( wxCommandEvent& event );
    void onCancel( wxCommandEvent& event );
    void onOK( wxCommandEvent& event );
    void onSetPage( wxCommandEvent& event );
    void onOperatorList( wxCommandEvent& event );
    void onCarList( wxCommandEvent& event );
    void OnCopy( wxCommandEvent& event );

};

#endif // __operatordlg__
