/** ------------------------------------------------------------
  * A U T O   G E N E R A T E D
  * Generator: Rocs ogen (build Jan 13 2012 15:28:16)
  * Module: RocDigs
  * XML: $Source: /cvsroot/rojav/rocdigs/rocdigs.xml,v $
  * XML: $Revision: 1.14 $
  * Date: Fri Jan 13 15:28:53 2012
  */

#ifndef __object_LocoNet_H
#define __object_LocoNet_H

#include "rocs/public/rocs.h"
#include "rocs/public/objbase.h"

/* Rocs includes: */
#include "rocs/public/node.h"
#include "rocs/public/serial.h"
#include "rocs/public/trace.h"
#include "rocs/public/thread.h"
#include "rocs/public/socket.h"

/* RocDigs and system includes: */
#include "rocint/public/digint.h"
#include <time.h>

#ifdef __cplusplus
  extern "C" {
#endif


typedef Boolean(*sublib_connect)(obj);
typedef void(*sublib_disconnect)(obj);
typedef int(*sublib_read)(obj,byte*);
typedef Boolean(*sublib_write)(obj,byte*,int);
typedef Boolean(*sublib_available)(obj);



typedef struct OLocoNet {
  /***** Base *****/
  struct OBase  base;

  /***** Interface: DigInt *****/
  /**  */
  iONode (*cmd)( obj inst ,const iONode cmd );
  /**  */
  void (*halt)( obj inst );
  /**  */
  Boolean (*setListener)( obj inst ,obj listenerObj ,const digint_listener listenerFun );
  /** external shortcut event */
  void (*shortcut)( obj inst );
  /** bit0=power, bit1=programming, bit2=connection */
  int (*state)( obj inst );
  /**  */
  Boolean (*supportPT)( obj inst );
  /** vmajor*1000 + vminor*100 + patch */
  int (*version)( obj inst );

  /***** Object: LocoNet *****/
  /**  */
  void (*ascii2byte)( const char* in ,int len ,byte* out );
  /**  */
  void (*byte2ascii)( const byte* in ,int len ,char* out );
  /**  */
  byte (*checksum)( const byte* cmd ,int len );
  /**  */
  void (*getSlot)( struct OLocoNet* inst ,int slot ,byte wait4opc );
  /**  */
  struct OLocoNet* (*inst)( const iONode ini ,const iOTrace trc );
  /**  */
  void (*stateChanged)( struct OLocoNet* inst );
  /**  */
  Boolean (*transact)( struct OLocoNet* inst ,byte* out ,int outsize ,byte* in ,int* insize ,byte waitforOPC_OK ,byte waitforOPC_FAIL ,Boolean post2slotserver );
  /**  */
  Boolean (*write)( struct OLocoNet* inst ,byte* out ,int outsize );
} *iOLocoNet;

extern struct OLocoNet LocoNetOp;

#ifdef __cplusplus
  }
#endif


#endif
