/** ------------------------------------------------------------
  * A U T O   G E N E R A T E D
  * Generator: Rocs ogen (build Jan 13 2012 15:28:16)
  * Module: RocInt
  * XML: $Source: /cvsroot/rojav/rocint/rocint.xml,v $
  * XML: $Revision: 1.4 $
  * Date: Fri Jan 13 15:28:19 2012
  */

#ifndef __object_BlockBase_H
#define __object_BlockBase_H

#include "rocs/public/rocs.h"
#include "rocs/public/objbase.h"

/* Rocs includes: */
#include "rocs/public/node.h"

/* RocInt and system includes: */
#include "rocrail/public/loc.h"

#ifdef __cplusplus
  extern "C" {
#endif





typedef struct IBlockBase {
  /***** Base *****/
  struct OBase  base;

  /***** Object: BlockBase *****/
  /**  */
  Boolean (*cmd)( struct IBlockBase* inst ,iONode cmd );
  /**  */
  void (*enterBlock)( struct IBlockBase* inst ,const char* locid );
  /**  */
  void (*event)( struct IBlockBase* inst ,Boolean puls ,const char* id ,int ident ,int val ,iONode evtDescr );
  /**  */
  const char* (*getFromBlockId)( struct IBlockBase* inst );
  /**  */
  const char* (*getInLoc)( struct IBlockBase* inst );
  /**  */
  const char* (*getLoc)( struct IBlockBase* inst );
  /**  */
  struct IBlockBase* (*getManager)( struct IBlockBase* inst );
  /**  */
  int (*getOccTime)( struct IBlockBase* inst );
  /**  */
  const char* (*getState)( struct IBlockBase* inst );
  /**  */
  int (*getTDaddress)( struct IBlockBase* inst );
  /**  */
  const char* (*getTDiid)( struct IBlockBase* inst );
  /**  */
  int (*getTDport)( struct IBlockBase* inst );
  /**  */
  const char* (*getVelocity)( struct IBlockBase* inst ,int* percent ,Boolean onexit );
  /**  */
  int (*getVisitCnt)( struct IBlockBase* inst ,const char* locid );
  /**  */
  int (*getWait)( struct IBlockBase* inst ,iOLoc loc );
  /**  */
  Boolean (*green)( struct IBlockBase* inst ,Boolean distant ,Boolean reverse );
  /**  */
  Boolean (*hasEnter2Route)( struct IBlockBase* inst ,const char* fromBlockId );
  /**  */
  obj (*hasManualSignal)( struct IBlockBase* inst ,Boolean distant ,Boolean reverse );
  /**  */
  Boolean (*hasPre2In)( struct IBlockBase* inst ,const char* fromBlockId );
  /**  */
  void (*inBlock)( struct IBlockBase* inst ,const char* locid );
  /**  */
  void (*init)( struct IBlockBase* inst );
  /**  */
  Boolean (*isFree)( struct IBlockBase* inst ,const char* locid );
  /**  */
  Boolean (*isLinked)( struct IBlockBase* inst );
  /**  */
  Boolean (*isReady)( struct IBlockBase* inst );
  /**  */
  int (*isSuited)( struct IBlockBase* inst ,iOLoc loc );
  /**  */
  Boolean (*isTerminalStation)( struct IBlockBase* inst );
  /**  */
  Boolean (*link)( struct IBlockBase* inst ,struct IBlockBase* linkto );
  /**  */
  Boolean (*lock)( struct IBlockBase* inst ,const char* locid ,const char* blockid ,const char* routeid ,Boolean crossing ,Boolean reset ,Boolean reverse );
  /**  */
  Boolean (*lockForGroup)( struct IBlockBase* inst ,const char* locid );
  /**  */
  Boolean (*red)( struct IBlockBase* inst ,Boolean distant ,Boolean reverse );
  /**  */
  void (*reset)( struct IBlockBase* inst );
  /**  */
  void (*resetTrigs)( struct IBlockBase* inst );
  /**  */
  void (*setAnalog)( struct IBlockBase* inst ,Boolean analog );
  /**  */
  void (*setDefaultAspect)( struct IBlockBase* inst );
  /**  */
  void (*setGroup)( struct IBlockBase* inst ,const char* group );
  /**  */
  Boolean (*setLocSchedule)( struct IBlockBase* inst ,const char* scid );
  /**  */
  void (*setManager)( struct IBlockBase* inst ,struct IBlockBase* manager );
  /**  */
  Boolean (*unLink)( struct IBlockBase* inst );
  /**  */
  Boolean (*unLock)( struct IBlockBase* inst ,const char* locid );
  /**  */
  Boolean (*unLockForGroup)( struct IBlockBase* inst ,const char* locid );
  /**  */
  Boolean (*wait)( struct IBlockBase* inst ,iOLoc loc );
  /**  */
  Boolean (*white)( struct IBlockBase* inst ,Boolean distant ,Boolean reverse );
  /**  */
  Boolean (*yellow)( struct IBlockBase* inst ,Boolean distant ,Boolean reverse );
} *iIBlockBase;


#ifdef __cplusplus
  }
#endif


#endif
