/** ------------------------------------------------------------
  * A U T O   G E N E R A T E D
  * Generator: Rocs ogen (build Jan 13 2012 15:28:16)
  * Module: RocRail
  * XML: $Source: /cvsroot/rojav/rocrail/rocrail.xml,v $
  * XML: $Revision: 1.56 $
  * Date: Fri Jan 13 15:28:19 2012
  */

#ifndef __object_Block_H
#define __object_Block_H

#include "rocs/public/rocs.h"
#include "rocs/public/objbase.h"

/* Rocs includes: */
#include "rocs/public/list.h"
#include "rocs/public/map.h"
#include "rocs/public/node.h"
#include "rocs/public/mutex.h"

/* RocRail and system includes: */
#include "rocrail/public/loc.h"
#include "rocrail/public/htmlint.h"
#include "rocint/public/blockbase.h"

#ifdef __cplusplus
  extern "C" {
#endif


typedef enum {enter_event=100,enter2in_event,in_event,exit_event,pre2in_event,ghost_event,occupied_event,ident_event,shortin_event} block_fbevent;
typedef enum {suits_not=0,suits_well=1,suits_ok=2} block_suits;
typedef void (*block_listener)(obj,block_fbevent);



typedef struct OBlock {
  /***** Base *****/
  struct OBase  base;

  /***** Interface: BlockBase *****/
  /**  */
  Boolean (*cmd)( iIBlockBase inst ,iONode cmd );
  /**  */
  void (*enterBlock)( iIBlockBase inst ,const char* locid );
  /**  */
  void (*event)( iIBlockBase inst ,Boolean puls ,const char* id ,int ident ,int val ,iONode evtDescr );
  /**  */
  const char* (*getFromBlockId)( iIBlockBase inst );
  /**  */
  const char* (*getInLoc)( iIBlockBase inst );
  /**  */
  const char* (*getLoc)( iIBlockBase inst );
  /**  */
  iIBlockBase (*getManager)( iIBlockBase inst );
  /**  */
  int (*getOccTime)( iIBlockBase inst );
  /**  */
  const char* (*getState)( iIBlockBase inst );
  /**  */
  int (*getTDaddress)( iIBlockBase inst );
  /**  */
  const char* (*getTDiid)( iIBlockBase inst );
  /**  */
  int (*getTDport)( iIBlockBase inst );
  /**  */
  const char* (*getVelocity)( iIBlockBase inst ,int* percent ,Boolean onexit );
  /**  */
  int (*getVisitCnt)( iIBlockBase inst ,const char* locid );
  /**  */
  int (*getWait)( iIBlockBase inst ,iOLoc loc );
  /**  */
  Boolean (*green)( iIBlockBase inst ,Boolean distant ,Boolean reverse );
  /**  */
  Boolean (*hasEnter2Route)( iIBlockBase inst ,const char* fromBlockId );
  /**  */
  obj (*hasManualSignal)( iIBlockBase inst ,Boolean distant ,Boolean reverse );
  /**  */
  Boolean (*hasPre2In)( iIBlockBase inst ,const char* fromBlockId );
  /**  */
  void (*inBlock)( iIBlockBase inst ,const char* locid );
  /**  */
  void (*init)( iIBlockBase inst );
  /**  */
  Boolean (*isFree)( iIBlockBase inst ,const char* locid );
  /**  */
  Boolean (*isLinked)( iIBlockBase inst );
  /**  */
  Boolean (*isReady)( iIBlockBase inst );
  /**  */
  int (*isSuited)( iIBlockBase inst ,iOLoc loc );
  /**  */
  Boolean (*isTerminalStation)( iIBlockBase inst );
  /**  */
  Boolean (*link)( iIBlockBase inst ,iIBlockBase linkto );
  /**  */
  Boolean (*lock)( iIBlockBase inst ,const char* locid ,const char* blockid ,const char* routeid ,Boolean crossing ,Boolean reset ,Boolean reverse );
  /**  */
  Boolean (*lockForGroup)( iIBlockBase inst ,const char* locid );
  /**  */
  Boolean (*red)( iIBlockBase inst ,Boolean distant ,Boolean reverse );
  /**  */
  void (*reset)( iIBlockBase inst );
  /**  */
  void (*resetTrigs)( iIBlockBase inst );
  /**  */
  void (*setAnalog)( iIBlockBase inst ,Boolean analog );
  /**  */
  void (*setDefaultAspect)( iIBlockBase inst );
  /**  */
  void (*setGroup)( iIBlockBase inst ,const char* group );
  /**  */
  Boolean (*setLocSchedule)( iIBlockBase inst ,const char* scid );
  /**  */
  void (*setManager)( iIBlockBase inst ,iIBlockBase manager );
  /**  */
  Boolean (*unLink)( iIBlockBase inst );
  /**  */
  Boolean (*unLock)( iIBlockBase inst ,const char* locid );
  /**  */
  Boolean (*unLockForGroup)( iIBlockBase inst ,const char* locid );
  /**  */
  Boolean (*wait)( iIBlockBase inst ,iOLoc loc );
  /**  */
  Boolean (*white)( iIBlockBase inst ,Boolean distant ,Boolean reverse );
  /**  */
  Boolean (*yellow)( iIBlockBase inst ,Boolean distant ,Boolean reverse );

  /***** Object: Block *****/
  /**  */
  int (*getEventCode)( const char* evtname );
  /**  */
  const char* (*getGroup)( struct OBlock* inst );
  /**  */
  struct OBlock* (*inst)( iONode ini );
  /**  */
  void (*modify)( struct OBlock* inst ,iONode modification );
  /**  */
  Boolean (*setListener)( struct OBlock* inst ,obj listenerObj ,const block_listener listenerFun );
  /**  */
  Boolean (*setManual)( struct OBlock* inst ,Boolean manual );
} *iOBlock;

extern struct OBlock BlockOp;

#ifdef __cplusplus
  }
#endif


#endif
