/** ------------------------------------------------------------
  * A U T O   G E N E R A T E D
  * Generator: Rocs ogen (build Jan 13 2012 15:28:16)
  * Module: RocRail
  * XML: $Source: /cvsroot/rojav/rocrail/rocrail.xml,v $
  * XML: $Revision: 1.56 $
  * Date: Fri Jan 13 15:28:19 2012
  */

#ifndef __object_Model_H
#define __object_Model_H

#include "rocs/public/rocs.h"
#include "rocs/public/objbase.h"

/* Rocs includes: */
#include "rocs/public/node.h"
#include "rocs/public/list.h"
#include "rocs/public/map.h"
#include "rocs/public/doc.h"
#include "rocs/public/mutex.h"
#include "rocs/public/file.h"

/* RocRail and system includes: */
#include <stdio.h>
#include "rocrail/public/block.h"
#include "rocrail/public/loc.h"
#include "rocrail/public/car.h"
#include "rocrail/public/operator.h"
#include "rocrail/public/route.h"
#include "rocrail/public/fback.h"
#include "rocrail/public/switch.h"
#include "rocrail/public/signal.h"
#include "rocrail/public/tt.h"
#include "rocrail/public/output.h"
#include "rocrail/public/seltab.h"
#include "rocrail/public/action.h"
#include "rocint/public/blockbase.h"

#ifdef __cplusplus
  extern "C" {
#endif


typedef void (*model_listener)(obj,iONode);



typedef struct OModel {
  /***** Base *****/
  struct OBase  base;

  /***** Object: Model *****/
  /**  */
  void (*addCoKey)( struct OModel* inst ,const char* key ,iOOutput co );
  /**  */
  void (*addFbKey)( struct OModel* inst ,const char* key ,iOFBack fb );
  /**  */
  void (*addListener)( struct OModel* inst ,model_listener listenerfun ,obj cargo );
  /**  */
  iIBlockBase (*addNetBlock)( struct OModel* inst ,iONode bkprops );
  /**  */
  iOLoc (*addNetLoc)( struct OModel* inst ,iONode lcprops );
  /**  */
  void (*addNetRoute)( struct OModel* inst ,iONode route );
  /**  */
  void (*addSwKey)( struct OModel* inst ,const char* key ,iOSwitch sw );
  /**  */
  void (*addSysEventListener)( struct OModel* inst ,obj listener );
  /**  */
  void (*analyse)( struct OModel* inst );
  /** returns the route to start with */
  iORoute (*calcRoute)( struct OModel* inst ,iOList routeList ,const char* fromBlockId ,const char* toLocationId ,const char* toBlockId ,iOLoc loc );
  /** returns the route to start with */
  iORoute (*calcRouteFromCurBlock)( struct OModel* inst ,iOList routeList ,const char* scheduleid ,int* scheduleIdx ,const char* curblockid ,iOLoc loc );
  /**  */
  iONode (*checkForBlockGroup)( struct OModel* inst ,const char* BlockId );
  /**  */
  Boolean (*cmd)( struct OModel* inst ,iONode cmd );
  /**  */
  void (*event)( struct OModel* inst ,iONode evt );
  /**  */
  iIBlockBase (*findDest)( struct OModel* inst ,const char* fromBlockId ,iOLoc loc ,iORoute* routeRef ,const char* gotoBlockId ,Boolean trysamedir ,Boolean tryoppositedir ,Boolean forcesamedir ,Boolean swapPlacingInPrevRoute );
  /** returns the fitting route */
  iORoute (*findRoute)( struct OModel* inst ,const char* scheduleid ,int* scheduleIdx ,const char* curblockid ,iOLoc loc );
  /**  */
  iOAction (*getAction)( struct OModel* inst ,const char* id );
  /**  */
  iIBlockBase (*getBlock)( struct OModel* inst ,const char* id );
  /**  */
  iOCar (*getCar)( struct OModel* inst ,const char* id );
  /**  */
  iOList (*getFBStat)( struct OModel* inst );
  /**  */
  iOFBack (*getFBack)( struct OModel* inst ,const char* id );
  /**  */
  iOList (*getLevelItems)( struct OModel* inst ,int level ,int* cx ,int* cy ,Boolean forserefresh );
  /**  */
  iOLoc (*getLoc)( struct OModel* inst ,const char* id );
  /**  */
  iOLoc (*getLocByAddress)( struct OModel* inst ,int decaddr );
  /**  */
  iOList (*getLocIDs)( struct OModel* inst );
  /**  */
  iONode (*getLocation)( struct OModel* inst ,const char* id );
  /**  */
  const char* (*getManagedID)( struct OModel* inst ,const char* blockid );
  /**  */
  const iONode (*getModPlan)( struct OModel* inst );
  /**  */
  const iONode (*getModel)( struct OModel* inst );
  /**  */
  const iONode (*getModule)( struct OModel* inst ,const char* modid );
  /**  */
  iOOperator (*getOperator)( struct OModel* inst ,const char* id );
  /**  */
  iOOutput (*getOutput)( struct OModel* inst ,const char* id );
  /**  */
  iORoute (*getRoute)( struct OModel* inst ,const char* id );
  /**  */
  iOList (*getRouteAliases)( struct OModel* inst ,const char* routeIds );
  /**  */
  iONode (*getSchedule)( struct OModel* inst ,const char* id );
  /**  */
  iOSelTab (*getSelectiontable)( struct OModel* inst ,const char* id );
  /**  */
  iOSignal (*getSignal)( struct OModel* inst ,const char* id );
  /**  */
  iOSwitch (*getSwitch)( struct OModel* inst ,const char* id );
  /**  */
  iOMap (*getSwitchMap)( struct OModel* inst );
  /**  */
  long (*getTime)( struct OModel* inst );
  /**  */
  const char* (*getTitle)( struct OModel* inst );
  /**  */
  iOTT (*getTurntable)( struct OModel* inst ,const char* id );
  /**  */
  void (*init)( struct OModel* inst );
  /**  */
  void (*initField)( struct OModel* inst );
  /**  */
  struct OModel* (*inst)( const char* planfile );
  /**  */
  Boolean (*isAuto)( struct OModel* inst );
  /**  */
  Boolean (*isCheck2In)( struct OModel* inst );
  /**  */
  Boolean (*isEnableSwFb)( struct OModel* inst );
  /**  */
  void (*loadBlockOccupation)( struct OModel* inst );
  /**  */
  Boolean (*modify)( struct OModel* inst ,iONode mod );
  /**  */
  Boolean (*modifyItem)( struct OModel* inst ,iONode mod );
  /**  */
  void (*printBlocks)( struct OModel* inst ,FILE * f );
  /**  */
  void (*printFBacks)( struct OModel* inst ,FILE * f );
  /**  */
  void (*printLocs)( struct OModel* inst ,FILE * f );
  /**  */
  void (*printRoutes)( struct OModel* inst ,FILE * f );
  /**  */
  void (*printSignals)( struct OModel* inst ,FILE * f );
  /**  */
  void (*printSwitches)( struct OModel* inst ,FILE * f );
  /**  */
  void (*removeCoKey)( struct OModel* inst ,const char* key );
  /**  */
  void (*removeFbKey)( struct OModel* inst ,const char* key );
  /**  */
  void (*removeSwKey)( struct OModel* inst ,const char* key );
  /**  */
  void (*save)( struct OModel* inst );
  /**  */
  void (*saveAs)( struct OModel* inst ,const char* filename );
  /**  */
  void (*saveBlockOccupation)( struct OModel* inst );
  /**  */
  void (*setBlockOccupation)( struct OModel* inst ,const char* BlockId ,const char* LocId ,Boolean closed ,int placing );
  /**  */
  void (*setModPlan)( struct OModel* inst ,iONode modplan );
  /**  */
  void (*setModel)( struct OModel* inst ,iONode model );
  /**  */
  void (*setModule)( struct OModel* inst ,iONode module );
  /**  */
  void (*stop)( struct OModel* inst );
  /**  */
  void (*updateFB)( struct OModel* inst );
} *iOModel;

extern struct OModel ModelOp;

#ifdef __cplusplus
  }
#endif


#endif
